## crossroads 2.65

=== Makefile ===
# Top-level Makefile for XR
# -------------------------

VER	   = 2.65
PREFIX	   = $(DESTDIR)/usr
BINDIR	   = $(PREFIX)/sbin
MANDIR	   = $(PREFIX)/share/man
TAR	   = /tmp/crossroads-$(VER).tar.gz
AUTHOR     = Karel Kubat <karel@kubat.nl>
MAINTAINER = Karel Kubat <karel@kubat.nl>
DISTSITE   = http://crossroads.e-tunity.com
BASE	   = $(shell pwd)

foo:
	@echo
	@echo 'Choose:'
	@echo ' make local     - local program construction'
	@echo ' make localprof - local, with profiling info'
	@echo ' make localmem  - local, with memory debugging'
	@echo ' make install   - installation to $(BINDIR)'
	@echo ' make uninstall - removes installed programs'
	@echo ' make clean     - removal after local/install'
	@echo ' make tar       - pack sources in an archive'
	@echo ' make commit    - commit to repository (maintainer only)'
	@echo

local:
	mkdir -p xr/build
	xr/etc/gettools /usr/local/bin xr/etc c-conf e-ver
	xr/etc/e-ver ChangeLog $(VER)
	BASE=$(BASE) AUTHOR='$(AUTHOR)' MAINTAINER='$(MAINTAINER)' \
	  DISTSITE='$(DISTSITE)' MEMDEBUG=$(MEMDEBUG)\
	  VER='$(VER)' PROF=$(PROF) PROFILER=$(PROFILER) $(MAKE) -C xr

localprof:
	PROF=-pg PROFILER=-DPROFILER make local

localmem:
	MEMDEBUG=-DMEMDEBUG make local

install: local $(BINDIR)/xrctl install-manpages
	mkdir -p $(BINDIR)
	BASE=$(BASE) AUTHOR='$(AUTHOR)' MAINTAINER='$(MAINTAINER)' \
	  DISTSITE='$(DISTSITE)' \
	  VER='$(VER)' BINDIR=$(BINDIR) $(MAKE) -C xr install
	@echo
	@echo '  The balancer program xr is now installed to $(BINDIR).'
	@echo '  The control script xrctl is installed there too. In order to'
	@echo '  use it, you will have to create /etc/xrctl.xml (if you have'
	@echo '  not done so yet). See "man xrctl.xml" for an example.'
	@echo 
	@echo '  Have fun with Crossroads $(VER),'
	@echo '    -- $(MAINTAINER)'
	@echo
$(BINDIR)/xrctl: xrctl/xrctl Makefile
	sed 's:__VER__:$(VER):' < xrctl/xrctl > $(BINDIR)/xrctl
	chmod +x $(BINDIR)/xrctl
install-manpages: $(MANDIR)/man1/xr.1 $(MANDIR)/man1/xrctl.1 \
		  $(MANDIR)/man5/xrctl.xml.5
$(MANDIR)/man1/xr.1: doc/xr.1
	mkdir -p $(MANDIR)/man1
	cp $< $@
$(MANDIR)/man1/xrctl.1: doc/xrctl.1
	mkdir -p $(MANDIR)/man1
	cp $< $@
$(MANDIR)/man5/xrctl.xml.5: doc/xrctl.xml.5
	mkdir -p $(MANDIR)/man5
	cp $< $@

uninstall:
	rm -f $(BINDIR)/xr $(BINDIR)/xrctl
	@echo
	@echo 'The balancer binary xr and the control script xrctl have been'
	@echo 'removed from $(BINDIR).'
	@echo
	@if [ -f /etc/xrctl.xml ] ; then \
	  echo 'The configuration /etc/xrctl.xml still exists. Remove this' ; \
	  echo 'by hand if you are sure you will not be needing it.'; \
	else \
	  echo 'Configuration /etc/xrctl.xml was not found. Maybe you have'; \
	  echo 'it in a different location or under a different name.'; \
	  echo 'If so, consider removing it by hand.'; \
	fi;
	@echo
	@echo 'XR was uninstalled!'

clean:
	rm -rf xr/build/*
	find . -name gmon.out -exec rm {} \;

tar: clean
	rm -rf $(TAR) /tmp/crossroads-$(VER)
	cd ..; cp -r crossroads /tmp/crossroads-$(VER)
	cd /tmp; tar czf $(TAR) \
	  --exclude .git --exclude .svn --exclude crossroads-$(VER)/xr/build \
	  crossroads-$(VER)
	rm -rf /tmp/crossroads-$(VER)
	@echo
	@echo 'Sources now tarred into $(TAR)'

commit: local clean
	test `svn status | grep '^\?' | wc -l` -eq 0 || \
		(echo 'SVN not fully up to date: run "svn status"' && exit 1)
	perl -c xrctl/xrctl
	svn -m $(VER) commit

=== xr/Makefile ===

# Configuration 
DIRS 	    	 = $(shell find . -type d | grep -v '.svn')
BUILDDIR    	 = build
BIN  	    	 = $(BUILDDIR)/xr
LIB  	    	 = $(BUILDDIR)/libxr.a
TMPXR       	 = /tmp/xr-$(shell whoami)
CONF_CC	    	 = $(shell etc/c-conf -c $(BUILDDIR)/config.cache c++-compiler)
CONF_OPTFLAGS	 = $(shell etc/c-conf -c $(BUILDDIR)/config.cache optflags)
CONF_LIB    	 = $(shell etc/c-conf -c $(BUILDDIR)/config.cache \
		     lib ucb nsl pthread socket m alf)
CONF_GETOPT 	 = $(shell etc/c-conf -c $(BUILDDIR)/config.cache \
		     ifheader getopt.h HAVE_GETOPT_H)
CONF_GETOPT_LONG = $(shell etc/c-conf -c $(BUILDDIR)/config.cache \
		     libfunction getopt_long HAVE_GETOPT_LONG)
CONF_INET_ATON   = $(shell etc/c-conf -c $(BUILDDIR)/config.cache \
		     libfunction inet_aton HAVE_INET_ATON)
CONF_STRNSTR	 = $(shell etc/c-conf -c $(BUILDDIR)/config.cache \
		     libfunction strnstr HAVE_STRNSTR)

foo:
	$(MAKE) subdirs
	$(MAKE) $(BIN)

install: $(BINDIR)/xr
$(BINDIR)/xr: $(BUILDDIR)/xr
	cp $(BUILDDIR)/xr $(TMPXR)
	strip $(TMPXR)
	install $(TMPXR) $(BINDIR)/xr
	rm -f $(TMPXR)

subdirs: $(BUILDDIR)/usage.h $(BUILDDIR)/status.xslt.h
	@echo 'About to build in class dirs: $(DIRS)'
	@for f in $(DIRS) ; do \
	   echo "Making: $$f"; \
	   BASE=$(BASE) CC=$(CONF_CC) BUILDDIR=$(BUILDDIR) VER='$(VER)' \
	     AUTHOR='$(AUTHOR)' MAINTAINER='$(MAINTAINER)' \
	     DISTSITE='$(DISTSITE)' MEMDEBUG=$(MEMDEBUG)\
	     CONF_CC='$(CONF_CC)' CONF_LIB='$(CONF_LIB)' \
	     CONF_GETOPT=$(CONF_GETOPT) CONF_GETOPT_LONG=$(CONF_GETOPT_LONG) \
	     CONF_INET_ATON=$(CONF_INET_ATON) CONF_OPTFLAGS='$(CONF_OPTFLAGS)' \
	     CONF_STRNSTR=$(CONF_STRNSTR) \
	     $(MAKE) -C $$f -f $(BASE)/xr/etc/Makefile.class \
	     || exit 1; \
	 done
	ar rs $(LIB) */*.o
	ranlib $(LIB)
$(BUILDDIR)/usage.h: etc/usage.txt
	etc/e-txt2c USAGE <etc/usage.txt >$(BUILDDIR)/usage.h
	touch config/parsecmdline.cc
$(BUILDDIR)/status.xslt.h: etc/status.xslt
	etc/e-txt2c XSLT  <etc/status.xslt >$(BUILDDIR)/status.xslt.h
	touch webinterface/answerxslt.cc

$(BIN): $(BUILDDIR)/libxr.a
	$(CONF_CC) $(PROF) $(CONF_OPTFLAGS) -g -o $(BIN) \
	  -L$(BUILDDIR) -lxr $(CONF_LIB)

clean:
	rm -f $(BIN) $(LIB) core obj/*.o etc/usage.h $(BUILDDIR)/config.cache
	find . -name \*.bak -exec rm {} \;

## crossroads 2.81

=== Makefile ===
--- 
+++ 
@@ -1,28 +1,18 @@
 # Top-level Makefile for XR
 # -------------------------
 
-VER	   = 2.65
-PREFIX	   = $(DESTDIR)/usr
-BINDIR	   = $(PREFIX)/sbin
-MANDIR	   = $(PREFIX)/share/man
-TAR	   = /tmp/crossroads-$(VER).tar.gz
-AUTHOR     = Karel Kubat <karel@kubat.nl>
-MAINTAINER = Karel Kubat <karel@kubat.nl>
-DISTSITE   = http://crossroads.e-tunity.com
-BASE	   = $(shell pwd)
+VER	   ?= 2.81
+PREFIX	   ?= $(DESTDIR)/usr
+BINDIR	   ?= $(PREFIX)/sbin
+MANDIR	   ?= $(PREFIX)/share/man
+TAR	   ?= /tmp/crossroads-$(VER).tar.gz
+AUTHOR     ?= Karel Kubat <karel@kubat.nl>
+MAINTAINER ?= Karel Kubat <karel@kubat.nl>
+DISTSITE   ?= http://crossroads.e-tunity.com
+BASE	   ?= $(shell pwd)
 
 foo:
-	@echo
-	@echo 'Choose:'
-	@echo ' make local     - local program construction'
-	@echo ' make localprof - local, with profiling info'
-	@echo ' make localmem  - local, with memory debugging'
-	@echo ' make install   - installation to $(BINDIR)'
-	@echo ' make uninstall - removes installed programs'
-	@echo ' make clean     - removal after local/install'
-	@echo ' make tar       - pack sources in an archive'
-	@echo ' make commit    - commit to repository (maintainer only)'
-	@echo
+	@cat xr/etc/make.help
 
 local:
 	mkdir -p xr/build
@@ -101,5 +91,9 @@
 commit: local clean
 	test `svn status | grep '^\?' | wc -l` -eq 0 || \
 		(echo 'SVN not fully up to date: run "svn status"' && exit 1)
+	test -f doc/xr.pdf || \
+		(echo 'PDF version of the docs not present!' && exit 1)
+	test doc/xr.pdf -nt doc/xr.odt || \
+		(echo 'PDF version of the docs is stale!!' && exit 1)
 	perl -c xrctl/xrctl
 	svn -m $(VER) commit

=== xr/Makefile ===
--- 
+++ 
@@ -23,8 +23,8 @@
 	$(MAKE) $(BIN)
 
 install: $(BINDIR)/xr
-$(BINDIR)/xr: $(BUILDDIR)/xr
-	cp $(BUILDDIR)/xr $(TMPXR)
+$(BINDIR)/xr: $(BIN)
+	cp $(BIN) $(TMPXR)
 	strip $(TMPXR)
 	install $(TMPXR) $(BINDIR)/xr
 	rm -f $(TMPXR)
@@ -35,10 +35,11 @@
 	   echo "Making: $$f"; \
 	   BASE=$(BASE) CC=$(CONF_CC) BUILDDIR=$(BUILDDIR) VER='$(VER)' \
 	     AUTHOR='$(AUTHOR)' MAINTAINER='$(MAINTAINER)' \
-	     DISTSITE='$(DISTSITE)' MEMDEBUG=$(MEMDEBUG)\
+	     DISTSITE='$(DISTSITE)' MEMDEBUG=$(MEMDEBUG) BINDIR='$(BINDIR)' \
 	     CONF_CC='$(CONF_CC)' CONF_LIB='$(CONF_LIB)' \
 	     CONF_GETOPT=$(CONF_GETOPT) CONF_GETOPT_LONG=$(CONF_GETOPT_LONG) \
-	     CONF_INET_ATON=$(CONF_INET_ATON) CONF_OPTFLAGS='$(CONF_OPTFLAGS)' \
+	     CONF_INET_ATON=$(CONF_INET_ATON) \
+	     CONF_OPTFLAGS='$(CONF_OPTFLAGS)' \
 	     CONF_STRNSTR=$(CONF_STRNSTR) \
 	     $(MAKE) -C $$f -f $(BASE)/xr/etc/Makefile.class \
 	     || exit 1; \
@@ -52,7 +53,7 @@
 	etc/e-txt2c XSLT  <etc/status.xslt >$(BUILDDIR)/status.xslt.h
 	touch webinterface/answerxslt.cc
 
-$(BIN): $(BUILDDIR)/libxr.a
+$(BIN): $(LIB)
 	$(CONF_CC) $(PROF) $(CONF_OPTFLAGS) -g -o $(BIN) \
 	  -L$(BUILDDIR) -lxr $(CONF_LIB)

=== debian/changelog ===
crossroads (2.81-2) unstable; urgency=medium

  * QA upload.
  * Bumped DH level to 10.
  * Run wrap-and-sort.
  * debian/control:
      - Added lsb-base to Depends field.
      - Changed Priority from extra to optional.
      - Reorganized the long description.
  * debian/copyright:
      - Added an extra email address for the main upstream.
      - Added the standard text for GPL-2+ and GPL-3.
      - Updated all information about the packaging.
      - Updated some information about the upstream rights.
  * debian/docs: added the debian/upstream/changelog-1.x file. See
    more details below.
  * debian/upstream/changelog-1.x: added to provide a upstream's changelog for
    1.x versions. It is useful to collect data to make the debian/copyright
    file and to have a history.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 29 Dec 2016 23:41:48 -0200

crossroads (2.81-1) unstable; urgency=low

  [ Reiner Herrmann ]
  * QA upload.
  * New upstream release.
    - Fix building with g++-6 (Closes: #811914).
  * Add watch file.
  * Convert to dh-style build.
  * Bump debhelper compatibility to version 9.
  * Use source format 3.0 (quilt).
  * Bump Standards-Version to 3.9.8.
  * Add Vcs-* fields.
  * Register documentation at doc-base.
  * Convert debian/copyright to DEP5.
  * debian/patches:
    - Refresh and add DEP3 headers.
    - Fix spelling errors found by lintian.
    - Support reproducible building.
    - Honour build flags for hardened build.
    - Don't strip binary to enable dbgsym packages.
    - Build verbosely to see compiler calls.

  [ Micah Anderson ]
  * Add init script and defaults file (Closes: #701210).

  [ Tone Kravanja ]
  * Make xrctl compatible with newer Perl version (LP: #1580924).

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 27 May 2016 16:31:04 +0200

crossroads (2.65-2) unstable; urgency=medium

  * QA upload.
  * Set Maintainer field to QA Group.
  * Bump Standards-Version to 3.9.6.
  * Add missing recommended targets to debian/rules: build-arch and
    build-indep.

 -- Emanuele Rocca <ema@debian.org>  Sun, 13 Dec 2015 14:38:31 +0100

crossroads (2.65-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: start.cc:22: undefined reference to `pthread_create'":
    add patch from Ubuntu / Andreas Moog:
    - debian/patches/ftbfs_link_pthread.patch: (LP: #749221)
      add missing link to pthread
    (Closes: #629658)

 -- gregor herrmann <gregoa@debian.org>  Mon, 31 Oct 2011 20:32:37 +0100

crossroads (2.65-1) unstable; urgency=low

  * Initial release (Closes: #498480)

 -- Stefan Ritter <xeno@thehappy.de>  Mon, 05 Jul 2010 16:27:00 +0200

=== debian/control ===
Source: crossroads
Section: net
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Homepage: http://crossroads.e-tunity.com/
Build-Depends: debhelper (>= 10)
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/crossroads.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/crossroads.git

Package: crossroads
Architecture: any
Depends: lsb-base, ${misc:Depends}, ${shlibs:Depends}
Description: open source load balance and fail over utility for TCP based services
 Crossroads is a daemon running in user space, and features extensive
 configurability, polling of back ends using 'wakeup calls', detailed
 status reporting, 'hooks' for special actions when backend calls fail,
 and much more.
 .
 Crossroads is service-independent: it is usable for HTTP(S), SSH, SMTP,
 DNS, etc. In the case of HTTP balancing, Crossroads can provide 'session
 stickiness' for back end processes that need sessions, but aren't
 session-aware of other back ends.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build -- local

override_dh_auto_install:
	dh_auto_install -- BINDIR=$(CURDIR)/debian/crossroads/usr/bin

=== debian/watch ===
version=3
https://crossroads.e-tunity.com/downloads/versions/crossroads-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## crossroads segmentation-0.1.28

=== requirements.txt ===
osmnx>=2.0.1
argparse
matplotlib
